﻿// Fill out your copyright notice in the Description page of Project Settings.


#include "Weapon/LMWeaponManager.h"

#include "Weapon/LMWeapon.h"


ULMWeaponManager::ULMWeaponManager()
{
	PrimaryComponentTick.bCanEverTick = false;
}

void ULMWeaponManager::BeginPlay()
{
	Super::BeginPlay();

	for (auto Weapon : StartingWeapons)
	{
		if (Weapon)
		{
			ULMWeapon* Instance = NewObject<ULMWeapon>(this, Weapon);
			Weapons.Add(Instance);

			// TODO
			// Instance->Initialize();
		}
	}

	if (!Weapons.IsEmpty())
	{
		SetWeapon(CurrentWeaponIndex);
	}
}

void ULMWeaponManager::AddAmmoType(uint8 AmmoType, int AmmoCount)
{
	FString Debug = FString::Printf(TEXT("Adding %i ammo of type %i"), AmmoCount, AmmoType);
	GEngine->AddOnScreenDebugMessage(1, 1.f, FColor::Cyan, Debug);
	
	for (const auto Weapon : Weapons)
	{
		// TODO : match weapon ammo type
		if (!Weapon)
			continue;

		// TODO
		// Weapon.AddAmmo(AmmoCount);
	}
}

void ULMWeaponManager::Fire()
{
	// ULMWeapon* Weapon = GetCurrentWeapon();
	
	GEngine->AddOnScreenDebugMessage(2, 1.f, FColor::Cyan, "Fire");
	// TODO
}

void ULMWeaponManager::Reload()
{
	GEngine->AddOnScreenDebugMessage(3, 1.f, FColor::Cyan, "Reloading");

	
	// ULMWeapon* Weapon = GetCurrentWeapon();
	// TODO
	// Weapon->Reload();
}

void ULMWeaponManager::SetWeapon(int Index)
{
	if (Index < 0 || Index >= Weapons.Num())
	{
		GEngine->AddOnScreenDebugMessage(INDEX_NONE, 5, FColor::Red, "Invalid Weapon Index");
		return;
	}

	CurrentWeaponIndex = Index;

	if (WeaponMeshComponent)
	{
		// TODO
		// WeaponMeshComponent->SetSkeletalMesh()
	}
}

