// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Character.h"
#include "LMPlayer.generated.h"

class ULMWeaponManager;

UCLASS()
class LEGUMEMIX_API ALMPlayer : public ACharacter
{
	GENERATED_BODY()

public:
	ALMPlayer();
	virtual void Tick(float DeltaTime) override;
	virtual void SetupPlayerInputComponent(class UInputComponent* PlayerInputComponent) override;

protected:
	virtual void BeginPlay() override;

public:	
	UFUNCTION(BlueprintCallable)
	ULMWeaponManager* GetWeaponManager() { return WeaponManager; }

private:
	UPROPERTY(VisibleAnywhere, BlueprintReadOnly, Category="Legumix", meta = (AllowPrivateAccess = true))
	TObjectPtr<ULMWeaponManager> WeaponManager;

	UPROPERTY(VisibleAnywhere, BlueprintReadOnly, Category="Legumix", meta = (AllowPrivateAccess = true))
	TObjectPtr<USkeletalMeshComponent> WeaponSkeletalMeshComponent;
};
